summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorFabian Groffen <grobian@gentoo.org>2018-01-02 17:18:01 +0100
committerFabian Groffen <grobian@gentoo.org>2018-01-02 17:18:01 +0100
commitce4edc8cdd9d6a2ec822de9ce37febb8b05402ff (patch)
tree54c7a2a2ffd614fb311f7e38ec628b95c81bc732 /sys-libs
parentsys-libs/libcxxabi: bump to 5.0.1 by Michael Weiser, bug #538364 (diff)
downloadprefix-ce4edc8cdd9d6a2ec822de9ce37febb8b05402ff.tar.gz
prefix-ce4edc8cdd9d6a2ec822de9ce37febb8b05402ff.tar.bz2
prefix-ce4edc8cdd9d6a2ec822de9ce37febb8b05402ff.zip
sys-libs/libcxx: bump to 5.0.1 by Michael Weiser, bug #538364
Bug: https://bugs.gentoo.org/538364 Package-Manager: Portage-2.3.18-prefix, Repoman-2.3.6
Diffstat (limited to 'sys-libs')
-rw-r--r--sys-libs/libcxx/Manifest2
-rw-r--r--sys-libs/libcxx/libcxx-3.9.0.ebuild157
-rw-r--r--sys-libs/libcxx/libcxx-5.0.1.ebuild230
3 files changed, 231 insertions, 158 deletions
diff --git a/sys-libs/libcxx/Manifest b/sys-libs/libcxx/Manifest
index d58be2fa2e..b998ef46cd 100644
--- a/sys-libs/libcxx/Manifest
+++ b/sys-libs/libcxx/Manifest
@@ -1,5 +1,5 @@
DIST libcxx-3.5.1.src.tar.xz 912248 BLAKE2B 9215341a119eb56be7f6cefe9b8de664ab2e9e5e208ab017aa73cd539c8f5f9e0b41209f245904793adf2933a72afd0aa2428fb1983480190d4e2f4e83e62e0d SHA512 3be33787c79aa5d03a3f507be20ef986215d6008e4f0370e3c5906d76a620bf27c9ed4c35f4561c1ac507a1b217fa7fc7577611e7205f3f2433c677bf86b8632
DIST libcxx-3.7.1.src.tar.xz 995724 BLAKE2B aab68f1b99a2c817e7154b71c04c81bd809154d1ae1c077a2dfede37319070729d6d768223b6ba5e2a866d6c2f18972dd501ce517864378ebc26c49cacafb635 SHA512 08d2399a8b36aa15290733256c896c9fa43f1a1223bc5c73bbcd014fddf8880e514d2a6dcc456bcf18b537c01fb6911b092e6d9958bccd8e64e9f375ed7a1ab9
DIST libcxx-3.8.1.src.tar.xz 1074164 BLAKE2B 8aa07974a0301684f852408a62c173084fb913179bec951df3bae33895f8b46434eddc95b838cb936a5ef31f5b8ead25b7d0e241adc039eaea38ef95045c8ccb SHA512 782ff3cdb85d02e92404e943474d0266ff601725c202f0667d60e7807f1ba3cfdebbdb062e27a52fec96be1c99339044be93a88ba7e396682f98d99c9ac175b2
-DIST libcxx-3.9.0.src.tar.xz 1198308 BLAKE2B 689fed969562466bd230445a0edb886880d1034c45d5387922d1dd307898547e5605035c5aa901f3e844be3c1b2d066cf27aa0b996d7ade176ee38a9f49ac98a SHA512 55d5c4adff378ee02b0b99d732bc9f326910f9e49ab8c320a588eccdd0362fe009bc9a6a4337d29faf6338420c91b10d0d7d67f66128268f01258d30502c4f4a
DIST libcxx-3.9.1.src.tar.xz 1209020 BLAKE2B 510e77c2c1163babbba904933f441e8720b0d366b9f0cfa2cdde2401368c224e00efd66afc1403b0087c40549cda4ebbc4d0c4b2d0906178324fa6158502d5ad SHA512 a5976e4096624a7307b3e43f4a22ac2dc74572226e0f57af9f3ef537a14c3cff1601b7042aef9dc40a0ee53ca76b08d72eb9c253dcf34f115d3153c302db7070
+DIST libcxx-5.0.1.src.tar.xz 1527852 BLAKE2B 9454fbca8228ee456feb79b65a63ce5daa27bf2e47e457d79592f4974dceeace19fe6cdeee51cc51f94e9072d7ce3c03e5acb617507670153647b9c435feadbd SHA512 994681d3c79047fc2d618c5584b08e9b5c925dab48f8812fc0adc81a575b49a637e9481bb9a0f7ae6f7f352b2b33f40056c347c27123cd6c96c6c226febd002c
diff --git a/sys-libs/libcxx/libcxx-3.9.0.ebuild b/sys-libs/libcxx/libcxx-3.9.0.ebuild
deleted file mode 100644
index 4d5e1ee549..0000000000
--- a/sys-libs/libcxx/libcxx-3.9.0.ebuild
+++ /dev/null
@@ -1,157 +0,0 @@
-# Copyright 1999-2016 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-# $Id $
-
-EAPI=5
-
-ESVN_REPO_URI="http://llvm.org/svn/llvm-project/libcxx/trunk"
-
-[ "${PV%9999}" != "${PV}" ] && SCM="subversion" || SCM=""
-
-inherit ${SCM} flag-o-matic toolchain-funcs cmake-multilib
-
-DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
-HOMEPAGE="http://libcxx.llvm.org/"
-if [ "${PV%9999}" = "${PV}" ] ; then
- SRC_URI="http://llvm.org/releases/${PV}/${P}.src.tar.xz"
- S="${WORKDIR}/${P}.src"
-else
- SRC_URI=""
-fi
-
-LICENSE="|| ( UoI-NCSA MIT )"
-SLOT="0"
-if [ "${PV%9999}" = "${PV}" ] ; then
- KEYWORDS="~x64-macos ~x86-macos"
-else
- KEYWORDS=""
-fi
-REQUIRED_USE="kernel_Darwin? ( libcxxabi !static-abi-lib )"
-IUSE="elibc_glibc libcxxrt +libcxxabi static-libs static-abi-lib test"
-
-RDEPEND="
- !kernel_Darwin? (
- libcxxrt? ( >=sys-libs/libcxxrt-0.0_p20130725[static-libs?,${MULTILIB_USEDEP}] )
- !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] )
- )
- kernel_Darwin? (
- =sys-libs/libcxx-headers-${PV}
- =sys-libs/libcxxabi-${PV}
- sys-devel/clang
- )"
-DEPEND="${RDEPEND}
- test? ( sys-devel/clang )
- app-arch/xz-utils
- static-abi-lib? (
- libcxxabi? ( sys-libs/libcxxabi[static-libs] )
- !libcxxabi? (
- libcxxrt? ( sys-libs/libcxxrt[static-libs] )
- )
- )
- "
-
-DOCS=( CREDITS.TXT )
-
-pkg_setup() {
- if [[ ${CHOST} == *darwin* ]] ; then
- MY_CC=$(tc-getCC)
- MY_CXX=$(tc-getCXX)
- if [[ ${MY_CC} != *clang* || ${MY_CXX} != *clang++* ]] ; then
- eerror "${PN} needs to be built with clang++. Please do not override"
- eerror "CC ($MY_CC) and CXX ($MY_CXX)"
- eerror "or point them at clang and clang++ respectively."
- die
- fi
- fi
- if ! use libcxxabi && ! use libcxxrt ; then
- ewarn "You have disabled USE=libcxxrt. This will build ${PN} against"
- ewarn "libsupc++. Please note that this is not well supported."
- ewarn "In particular, static linking will not work."
- fi
- if [[ $(gcc-version) < 4.7 ]] && [[ $(tc-getCXX) != *clang++* ]] ; then
- eerror "${PN} needs to be built with clang++ or gcc-4.7 or later."
- eerror "Please use gcc-config to switch to gcc-4.7 or later version."
- die
- fi
-}
-
-src_prepare() {
- sed -i -e "/set.LLVM_CMAKE_PATH.*\\/cmake\\/modules/s@cmake/modules@cmake@" cmake/Modules/HandleOutOfTreeLLVM.cmake
-
- # The library can only be built as either shared or static. So use two
- # separate build dirs with separate configurations.
- BUILD_DIR_SHARED=${WORKDIR}/${P}_build
- BUILD_DIR_STATIC=${WORKDIR}/${P}_build_static
-}
-
-src_configure() {
- local mycmakeargs=(
- -DLLVM_PATH=${EPREFIX}/usr/share/llvm
- -DLIBCXX_INSTALL_HEADERS=NO
- )
-
- # make sure we build multilib on OSX, because llvm insists on
- # building multilib too
- [[ ${CHOST} == *86*-darwin* ]] && append-flags -arch i386 -arch x86_64
-
- if use libcxxabi ; then
- mycmakeargs+=(
- -DLIBCXX_CXX_ABI=libcxxabi
- # avoid guessing of libcxxabi version by installed SDK discovered
- # via xc-run - we know better because we require a libcxxabi version
- # matching our own
- -DLIBCXX_LIBCPPABI_VERSION=2
- # avoid configure warning about not being able to find cxxabi.h
- -DLIBCXX_CXX_ABI_INCLUDE_PATHS=${EPREFIX}/usr/include
- )
- elif use libcxxrt ; then
- mycmakeargs+=( -DLIBCXX_CXX_ABI=libcxxrt )
- else
- mycmakeargs+=( -DLIBCXX_CXX_ABI=libsupc++ )
- fi
-
- use static-abi-lib && mycmakeargs+=( -DLIBCXX_ENABLE_STATIC_ABI_LIBRARY=ON )
- use test && mycmakeargs+=( -DLIBCXX_INCLUDE_TESTS=ON )
-
- BUILD_DIR=${BUILD_DIR_SHARED} cmake-multilib_src_configure
- if use static-libs ; then
- mycmakeargs+=( -DLIBCXX_ENABLE_SHARED=NO )
- BUILD_DIR=${BUILD_DIR_STATIC} cmake-multilib_src_configure
- fi
-}
-
-src_compile() {
- BUILD_DIR=${BUILD_DIR_SHARED} cmake-multilib_src_compile
-
- # reconfigure and recompile for additional static libs if enabled
- use static-libs && \
- BUILD_DIR=${BUILD_DIR_STATIC} cmake-multilib_src_compile
-}
-
-src_test() {
- BUILD_DIR=${BUILD_DIR_SHARED} cmake-multilib_src_test
- use static-libs && \
- BUILD_DIR=${BUILD_DIR_STATIC} cmake-multilib_src_test
-}
-
-multilib_src_test() {
- cmake-utils_src_make check-libcxx
-}
-
-src_install() {
- BUILD_DIR=${BUILD_DIR_SHARED} cmake-multilib_src_install
- use static-libs && \
- BUILD_DIR=${BUILD_DIR_STATIC} cmake-multilib_src_install
-}
-
-multilib_src_install_all() {
- einstalldocs
-}
-
-pkg_postinst() {
- elog "This package (${PN}) is mainly intended as a replacement for the C++"
- elog "standard library when using clang."
- elog "To use it, instead of libstdc++, use:"
- elog " clang++ -stdlib=libc++"
- elog "to compile your C++ programs."
-}
diff --git a/sys-libs/libcxx/libcxx-5.0.1.ebuild b/sys-libs/libcxx/libcxx-5.0.1.ebuild
new file mode 100644
index 0000000000..889825b71c
--- /dev/null
+++ b/sys-libs/libcxx/libcxx-5.0.1.ebuild
@@ -0,0 +1,230 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=6
+
+# Ninja provides better scalability and cleaner verbose output, and is used
+# throughout all LLVM projects.
+: ${CMAKE_MAKEFILE_GENERATOR:=ninja}
+EGIT_REPO_URI="http://llvm.org/git/libcxx.git
+ https://github.com/llvm-mirror/libcxx.git"
+PYTHON_COMPAT=( python2_7 )
+
+[[ ${PV} == 9999 ]] && SCM="git-r3" || SCM=""
+
+inherit ${SCM} cmake-multilib python-any-r1 toolchain-funcs flag-o-matic
+
+DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
+HOMEPAGE="http://libcxx.llvm.org/"
+if [[ ${PV} != 9999 ]] ; then
+ SRC_URI="http://llvm.org/releases/${PV}/${P}.src.tar.xz"
+ S="${WORKDIR}/${P}.src"
+else
+ SRC_URI=""
+fi
+
+LICENSE="|| ( UoI-NCSA MIT )"
+SLOT="0"
+if [[ ${PV} != 9999 ]] ; then
+ KEYWORDS="~x64-macos ~x86-macos"
+else
+ KEYWORDS=""
+fi
+IUSE="elibc_Darwin elibc_glibc elibc_musl +libcxxabi libcxxrt libunwind +static-libs test"
+REQUIRED_USE="libunwind? ( || ( libcxxabi libcxxrt ) )
+ elibc_Darwin? ( libcxxabi )
+ ?? ( libcxxabi libcxxrt )"
+
+RDEPEND="
+ libcxxabi? ( ~sys-libs/libcxxabi-${PV}[libunwind=,static-libs?,${MULTILIB_USEDEP}] )
+ !elibc_Darwin? (
+ libcxxrt? ( sys-libs/libcxxrt[libunwind=,static-libs?,${MULTILIB_USEDEP}] )
+ !libcxxabi? ( !libcxxrt? ( >=sys-devel/gcc-4.7:=[cxx] ) )
+ )
+ elibc_Darwin? ( !sys-libs/libcxx-headers )"
+# llvm-3.9.0 needed because its cmake files installation path changed, which is
+# needed by libcxx
+# clang-3.9.0 installs necessary target symlinks unconditionally
+# which removes the need for MULTILIB_USEDEP
+DEPEND="${RDEPEND}
+ test? ( >=sys-devel/clang-3.9.0
+ $(python_gen_any_dep 'dev-python/lit[${PYTHON_USEDEP}]') )
+ app-arch/xz-utils
+ >=sys-devel/llvm-3.9.0"
+
+DOCS=( CREDITS.TXT )
+
+PATCHES=(
+ # Add link flag "-Wl,-z,defs" to avoid underlinking; this is needed in a
+ # out-of-tree build.
+ "${FILESDIR}/${PN}-3.9-cmake-link-flags.patch"
+)
+
+python_check_deps() {
+ has_version "dev-python/lit[${PYTHON_USEDEP}]"
+}
+
+pkg_setup() {
+ use test && python-any-r1_pkg_setup
+
+ if ! use libcxxabi && ! use libcxxrt && ! tc-is-gcc ; then
+ eerror "To build ${PN} against libsupc++, you have to use gcc. Other"
+ eerror "compilers are not supported. Please set CC=gcc and CXX=g++"
+ eerror "and try again."
+ die
+ fi
+ if tc-is-gcc && [[ $(gcc-version) < 4.7 ]] ; then
+ eerror "${PN} needs to be built with gcc-4.7 or later (or other"
+ eerror "conformant compilers). Please use gcc-config to switch to"
+ eerror "gcc-4.7 or later version."
+ die
+ fi
+}
+
+src_configure() {
+ NATIVE_LIBDIR=$(get_libdir)
+ cmake-multilib_src_configure
+}
+
+multilib_src_configure() {
+ local cxxabi cxxabi_incs
+ if use libcxxabi; then
+ cxxabi=libcxxabi
+ cxxabi_incs="${EPREFIX}/usr/include/libcxxabi"
+ elif use libcxxrt; then
+ cxxabi=libcxxrt
+ cxxabi_incs="${EPREFIX}/usr/include/libcxxrt"
+ else
+ local gcc_inc="${EPREFIX}/usr/lib/gcc/${CHOST}/$(gcc-fullversion)/include/g++-v$(gcc-major-version)"
+ cxxabi=libsupc++
+ cxxabi_incs="${gcc_inc};${gcc_inc}/${CHOST}"
+ fi
+
+ # we want -lgcc_s for unwinder, and for compiler runtime when using
+ # gcc, clang with gcc runtime (or any unknown compiler)
+ local extra_libs=() want_gcc_s=ON
+ if use libunwind; then
+ # work-around missing -lunwind upstream
+ extra_libs+=( -lunwind )
+ # if we're using libunwind and clang with compiler-rt, we want
+ # to link to compiler-rt instead of -lgcc_s
+ if tc-is-clang; then
+ # get the full library list out of 'pretend mode'
+ # and grep it for libclang_rt references
+ local args=( $($(tc-getCC) -### -x c - 2>&1 | tail -n 1) )
+ local i
+ for i in "${args[@]}"; do
+ if [[ ${i} == *libclang_rt* ]]; then
+ want_gcc_s=OFF
+ extra_libs+=( "${i}" )
+ fi
+ done
+ fi
+ fi
+ # Darwin has libunwind in its system
+ [[ ${CHOST} == *-darwin* ]] && want_gcc_s=OFF
+
+ local libdir=$(get_libdir)
+ local mycmakeargs=(
+ # LLVM_LIBDIR_SUFFIX is used to find CMake files
+ # and we are happy to use the native set
+ -DLLVM_LIBDIR_SUFFIX=${NATIVE_LIBDIR#lib}
+ -DLIBCXX_LIBDIR_SUFFIX=${libdir#lib}
+ -DLIBCXX_ENABLE_SHARED=ON
+ -DLIBCXX_ENABLE_STATIC=$(usex static-libs)
+ -DLIBCXX_CXX_ABI=${cxxabi}
+ -DLIBCXX_CXX_ABI_INCLUDE_PATHS=${cxxabi_incs}
+ # we're using our own mechanism for generating linker scripts
+ -DLIBCXX_ENABLE_ABI_LINKER_SCRIPT=OFF
+ -DLIBCXX_HAS_MUSL_LIBC=$(usex elibc_musl)
+ -DLIBCXX_HAS_GCC_S_LIB=${want_gcc_s}
+ -DLIBCXX_INCLUDE_TESTS=$(usex test)
+ -DCMAKE_SHARED_LINKER_FLAGS="${extra_libs[*]} ${LDFLAGS}"
+ # avoid guessing of libcxxabi version by installed SDK discovered
+ # via xc-run - we know better because we require a libcxxabi version
+ # matching our own
+ -DLIBCXX_LIBCPPABI_VERSION=2
+ )
+
+ if use test; then
+ mycmakeargs+=(
+ # this can be any directory, it just needs to exist...
+ -DLLVM_MAIN_SRC_DIR="${T}"
+ -DLIT_COMMAND="${EPREFIX}"/usr/bin/lit
+ )
+ fi
+
+ # make sure we build multilib on OSX, because llvm insists on
+ # building multilib too
+ [[ ${CHOST} == *86*-darwin* ]] && append-flags -arch i386 -arch x86_64
+
+ cmake-utils_src_configure
+}
+
+multilib_src_test() {
+ local clang_path=$(type -P "${CHOST:+${CHOST}-}clang" 2>/dev/null)
+
+ [[ -n ${clang_path} ]] || die "Unable to find ${CHOST}-clang for tests"
+ sed -i -e "/cxx_under_test/s^\".*\"^\"${clang_path}\"^" test/lit.site.cfg || die
+
+ cmake-utils_src_make check-libcxx
+}
+
+# Usage: deps
+gen_ldscript() {
+ local output_format
+ output_format=$($(tc-getCC) ${CFLAGS} ${LDFLAGS} -Wl,--verbose 2>&1 | sed -n 's/^OUTPUT_FORMAT("\([^"]*\)",.*/\1/p')
+ [[ -n ${output_format} ]] && output_format="OUTPUT_FORMAT ( ${output_format} )"
+
+ cat <<-END_LDSCRIPT
+/* GNU ld script
+ Include missing dependencies
+*/
+${output_format}
+GROUP ( $@ )
+END_LDSCRIPT
+}
+
+gen_static_ldscript() {
+ local libdir=$(get_libdir)
+ local cxxabi_lib=$(usex libcxxabi "libc++abi.a" "$(usex libcxxrt "libcxxrt.a" "libsupc++.a")")
+
+ # Move it first.
+ mv "${ED}/usr/${libdir}/libc++.a" "${ED}/usr/${libdir}/libc++_static.a" || die
+ # Generate libc++.a ldscript for inclusion of its dependencies so that
+ # clang++ -stdlib=libc++ -static works out of the box.
+ local deps="libc++_static.a ${cxxabi_lib} $(usex libunwind libunwind.a libgcc_eh.a)"
+ # On Linux/glibc it does not link without libpthread or libdl. It is
+ # fine on FreeBSD.
+ use elibc_glibc && deps+=" libpthread.a libdl.a"
+
+ gen_ldscript "${deps}" > "${ED}/usr/${libdir}/libc++.a" || die
+}
+
+gen_shared_ldscript() {
+ local libdir=$(get_libdir)
+ # libsupc++ doesn't have a shared version
+ local cxxabi_lib=$(usex libcxxabi "libc++abi.so" "$(usex libcxxrt "libcxxrt.so" "libsupc++.a")")
+
+ mv "${ED}/usr/${libdir}/libc++.so" "${ED}/usr/${libdir}/libc++_shared.so" || die
+ local deps="libc++_shared.so ${cxxabi_lib} $(usex libunwind libunwind.so libgcc_s.so)"
+
+ gen_ldscript "${deps}" > "${ED}/usr/${libdir}/libc++.so" || die
+}
+
+multilib_src_install() {
+ cmake-utils_src_install
+ if [[ ${CHOST} != *-darwin* ]] ; then
+ gen_shared_ldscript
+ use static-libs && gen_static_ldscript
+ fi
+}
+
+pkg_postinst() {
+ elog "This package (${PN}) is mainly intended as a replacement for the C++"
+ elog "standard library when using clang."
+ elog "To use it, instead of libstdc++, use:"
+ elog " clang++ -stdlib=libc++"
+ elog "to compile your C++ programs."
+}